﻿using System;
using System.Collections.Generic;
using Pixiview.Resources;
using Pixiview.Utils;
using Xamarin.Essentials;
using Xamarin.Forms;

namespace Pixiview.Illust
{
    public partial class FavoritesPage : FavoriteIllustCollectionPage
    {
        public FavoritesPage()
        {
            Resources.Add("cardView", GetCardViewTemplate());
            InitializeComponent();
        }

        protected override bool IsFavoriteVisible => false;

        public override void OnUnload()
        {
        }

        protected override void OnAppearing()
        {
            //base.OnAppearing();
            Device.StartTimer(TimeSpan.FromMilliseconds(200), () =>
            {
                Reload();
                return false;
            });
        }

        protected override IEnumerable<IllustItem> DoGetIllustList(IllustItem[] data)
        {
            return data;
        }

        protected override IllustItem[] DoLoadIllustData(bool force)
        {
            var favorites = Stores.GetFavoriteObject(force);
            if (favorites == null)
            {
                return null;
            }
            return favorites.Illusts.ToArray();
        }

        public void Reload(bool force = false)
        {
            lastUpdated = default;
            StartLoad(force);
        }

        private async void ShareFavorites_Clicked(object sender, EventArgs e)
        {
            var file = Stores.FavoritesPath;
            await Share.RequestAsync(new ShareFileRequest
            {
                Title = ResourceHelper.Favorites,
                File = new ShareFile(file)
            });
        }
    }
}
