﻿using System;
using System.Collections.Generic;
using System.Linq;
using Pixiview.Utils;
using Xamarin.Forms;

namespace Pixiview.Illust
{
    public partial class UserIllustPage : IllustUserDataCollectionPage
    {
        public static readonly BindableProperty UserIconProperty = BindableProperty.Create(
            nameof(UserIcon), typeof(ImageSource), typeof(UserIllustPage));

        public ImageSource UserIcon
        {
            get => (ImageSource)GetValue(UserIconProperty);
            set => SetValue(UserIconProperty, value);
        }

        public IIllustUser UserItem { get; }

        public UserIllustPage(IIllustUser item)
        {
            UserItem = item;
            UserIcon = item.ProfileImage;

            Resources.Add("cardView", GetCardViewTemplate(true));
            InitializeComponent();
        }

        protected override IEnumerable<IllustItem> DoGetIllustList(IllustUserData data)
        {
            return data.body.works.Select(i => i.Value?.ConvertToItem());
        }

        protected override IllustUserData DoLoadIllustData(bool force)
        {
            return Stores.LoadIllustUserData(UserItem.UserId, force);
        }

        private void Refresh_Clicked(object sender, EventArgs e)
        {
            if (IsLoading)
            {
                return;
            }
            StartLoad(true);
        }
    }
}
